﻿using System;
using System.IO;
using System.Reflection;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using DX = Microsoft.DirectX;
using D3DX = Microsoft.DirectX.Direct3D;

namespace ModelEx
{
    class Effect : Project.Resource
    {
        internal D3DX.Effect D3DXEffect;
        String Text;

        Effect(Project project, String name) :
            base(project, name)
        {
        }

        ~Effect()
        {
        }

        public static Effect Create(Project project, String name)
        {
            Effect effect = project.FindEffect(name);
            return (effect != null) ? effect : new Effect(project, name);
        }

        public override void Load(String folderName)
        {
        }

        public void LoadFromMemory(String resourceName)
        {
            Assembly executingAssembly = Assembly.GetExecutingAssembly();
            Stream stream = executingAssembly.GetManifestResourceStream(GetType(), resourceName);
            StreamReader reader = new StreamReader(stream);
            Text = reader.ReadToEnd();
            reader.Close();

            String strErrors = null;
            D3DXEffect = D3DX.Effect.FromString(
                Device,
                Text,
                null,
                null,
                ShaderFlags.None,
                null,
                out strErrors
            );
        }
    }
}
