﻿using System;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using DX = Microsoft.DirectX;
using D3DX = Microsoft.DirectX.Direct3D;

namespace ModelEx
{
    class Texture : Project.Resource
    {
        internal D3DX.Texture D3DXTexture;

        Texture(Project project, String name) :
            base(project, name)
        {
        }

        ~Texture()
        {
        }

        public static Texture Create(Project project, String name)
        {
            Texture texture = project.FindTexture(name);
            return (texture != null) ? texture : new Texture(project, name);
        }

        public override void Load(String folderName)
        {
            ImageInformation imageInfo = TextureLoader.ImageInformationFromFile(Name);
            D3DXTexture = TextureLoader.FromFile(
                Device,
                Name,
                imageInfo.Width,
                imageInfo.Height,
                imageInfo.MipLevels,
                Usage.None,
                imageInfo.Format,
                Pool.Managed,
                Filter.None,
                Filter.None,
                0x00000000
            );
        }

        public void Save(String strFileName)
        {
            if (D3DXTexture != null)
            {
                TextureLoader.Save(strFileName, ImageFileFormat.Dds, D3DXTexture);
            }
        }
    }
}
