﻿using System;
using System.Collections.Generic;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using DX = Microsoft.DirectX;
using D3DX = Microsoft.DirectX.Direct3D;

namespace ModelEx
{
    class Triangles : Project.Resource
    {
        public struct SourceMapping
        {
            public Source[] Sources;
            public Int32[] Indices;
        }

        internal Material Material;
        internal VertexBuffer VertexBuffer;
        internal Int32 VertexCount;
        internal VertexFormats VertexFormat;
        internal Int32 Stride;
        internal IndexBuffer IndexBuffer;
        internal Int32 IndexCount;
        internal List<SourceMapping> SourceMappings;

        Triangles(Project project, String name) :
            base(project, name)
        {
            SourceMappings = new List<SourceMapping>();
        }

        ~Triangles()
        {
        }

        public static Triangles Create(Project project, String name)
        {
            Triangles indexBuffer = project.FindTriangles(name);
            return (indexBuffer != null) ? indexBuffer : new Triangles(project, name);
        }

        public override void Load(String folderName)
        {
        }

        public void AddSourceMapping(Source[] sources, Int32[] indices)
        {
            if (sources == null || indices == null)
            {
                return;
            }

            SourceMapping mapping = new SourceMapping();
            mapping.Sources = sources;
            mapping.Indices = indices;

            SourceMappings.Add(mapping);
        }
    }
}