﻿using System;
using System.Drawing;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using DX = Microsoft.DirectX;
using D3DX = Microsoft.DirectX.Direct3D;

namespace ModelEx
{
    class ModelExFont
    {
        Device Device;
        D3DX.Font Font;
        D3DX.Sprite Sprite;

        public ModelExFont(Device device, String name, float size)
        {
            Device = device;

            System.Drawing.Font systemFont = new System.Drawing.Font(name, size, FontStyle.Regular, GraphicsUnit.Pixel);
            Font = new D3DX.Font(Device, systemFont);

            Sprite = new Sprite(Device);
        }

        public void Print(String text, Rectangle rect, UInt32 colour)
        {
            Sprite.Begin(SpriteFlags.AlphaBlend);

            Font.DrawText(
                Sprite,
                text,
                rect,
                DrawTextFormat.WordBreak | DrawTextFormat.Top | DrawTextFormat.Left,
                Color.FromArgb((Int32)colour)
            );

            Sprite.End();
        }

        public Rectangle MeasureString(String text)
        {
            return Font.MeasureString(
                Sprite,
                text,
                DrawTextFormat.WordBreak | DrawTextFormat.Top | DrawTextFormat.Left,
                unchecked((Int32)0xFFFFFFFF)
            );
        }
    }
}
